'=========================================================================
' Schwingende Membran
' MEMBRAN.BAS
' Autor: Lothar Schirm
' Letzte Ueberarbeitung 11.03.08
'=========================================================================

#include "3D-GRAPH.BAS"

DIM AS SINGLE pi, dx, dy, dt, t, x(50), y(50), z(50, 50)
DIM AS INTEGER p, q, i, j

SCREEN 0
COLOR 7, 1
CLS
PRINT "Programm MEMBRAN zeichnet die Schwingungen einer quadratischen "
PRINT "Membran mit der Kantenlaenge 1:"
PRINT
PRINT "z = sin(p * pi * x ) * sin(q * pi * y) * sin(2 * pi * f * t)."
PRINT "pi = 3.141593, p und q ganze Zahlen."


SCREEN 12
COLOR 0, 15
CLS
WINDOW(-0.5, -0.8) - (1.2, 0.5)

pi = 3.141593
dx = 0.02
dy = 0.02
dt = 0.1

DO
  PRINT "Gib fuer p und q ganze Zahlen ein (p = 0 zum Beenden):"
  INPUT "p = ", p
  IF p = 0 THEN END
  INPUT "q = ", q
  t = 0
  DO
    LOCATE 29, 1: PRINT "Beenden: Beliebige Taste!"
    t = t + dt
    FOR i = 0 TO 50
      x(i) = i * dx
      FOR j = 0 TO 50
        y(j) = j * dy
        z(i, j) = 0.05 * SIN(p * pi * x(i)) * SIN(q * pi * y(j)) * SIN(t)
      NEXT j
    NEXT i
    xyzGraphik(x(), y(), z(), 50, 50, -20, 20, 4, 0)
    SLEEP 50
    CLS
  LOOP UNTIL INKEY <> ""
LOOP



